  
DECLARE 
  v_exists integer;
BEGIN
  SELECT count(*) 
    INTO v_exists
    FROM USER_TABLES 
    WHERE TABLE_NAME='LAYERSYSHISTORY';
  IF (v_exists=0) THEN
    EXECUTE IMMEDIATE '
  CREATE TABLE LAYERSYSHISTORY
   (	ID NUMBER(10,0) NOT NULL, 
      LAYERREF NUMBER(10,0) NOT NULL, 
      OPERATION NUMBER(10,0) NOT NULL,
	    RECORDID NUMBER(10,0) NOT NULL, 
      CAPTIONID NUMBER(10,0), 
	    OSUSER VARCHAR2(50) NOT NULL, 
      SYSTEMUSER VARCHAR2(50) NOT NULL, 
      PCNAME VARCHAR2(50), 
      NATURALKEY VARCHAR2(50),       
      UPDATEDATE DATE,
      
	 CHECK ((ID<=2147483647)AND(ID>-2147483648)),
   CHECK ((LAYERREF<=2147483647)AND(LAYERREF>-2147483648)), 
	 CHECK ((OPERATION<=2147483647)AND(OPERATION>-2147483648)), 
	 CHECK ((RECORDID<=2147483647)AND(RECORDID>-2147483648)), 
	 CHECK ((CAPTIONID<=2147483647)AND(CAPTIONID>-2147483648)), 
   
	 CONSTRAINT "FK_L_HIST_LAYER" FOREIGN KEY (LAYERREF)
	  REFERENCES LAYERS (ID)
    )';

    EXECUTE IMMEDIATE 'CREATE INDEX IDX_L_HIST_LAYER ON LAYERSYSHISTORY (LAYERREF)';
    EXECUTE IMMEDIATE 'CREATE INDEX IDX_L_HIST_UPDATEDATE ON LAYERSYSHISTORY (UPDATEDATE)';
    EXECUTE IMMEDIATE 'CREATE INDEX IDX_L_HIST_RECORDID ON LAYERSYSHISTORY (RECORDID)';
  END IF;
END;
/
  
CREATE OR REPLACE TRIGGER TR_L_HIST_BI 
  BEFORE INSERT
  ON LAYERSYSHISTORY
  FOR EACH ROW
begin
  if (:new.id is null) then select G_SHARED.nextval into :new.Id from DUAL; end if;
  if (:new.UpdateDate is NULL) then  :NEW.UpdateDate := SYSDATE; End if;
end;
/ 

CREATE OR REPLACE TRIGGER TR_L_HIST_BU 
  BEFORE UPDATE
  ON LAYERSYSHISTORY
  FOR EACH ROW
begin
  raise_application_error(-20503,'Modifying changes history is prohibited');
end;
/

  
COMMIT WORK;  
  

  